#!/usr/bin/env bash

echo "================================"
echo "<===== Run build.sh ====>"
echo "================================"

set -e


info() {
echo -e "\e[33m [Info]     \e[33m$1 \e[39m"
}


success() {
echo -e "\e[32m [Success] \e[32m $1 \e[39m"
}

info "build started under user $(whoami)"

echo "Make database for testing ${pwd}"
touch database/database.unit.sqlite
touch database/database.dusk.sqlite

info "Install environment for unit tests"
cp .env.unit .env


info "Install requirements >>>>> "
composer install --no-interaction --prefer-dist


info "Generate application key >>>>>> "
php artisan key:generate


info "Start unit test >>>>> "
php artisan test


info "Setup environment for dusk test"
cp .env.dusk .env

php artisan key:generate

# Устанавливем браузер нужной версии для тестов
VERSION_STRING="114.0.5735.90" # Replace this value with the one you copied earlier
wget "https://dl.google.com/linux/chrome/deb/pool/main/g/google-chrome-stable/google-chrome-stable_${VERSION_STRING}_amd64.deb"
sudo dpkg -i "google-chrome-stable_${VERSION_STRING}_amd64.deb"
rm -i "google-chrome-stable_${VERSION_STRING}_amd64.deb"

php artisan dusk:chrome-driver 114
nohup bash -c "php artisan serve --env=dusk --port=4343 2>&1 &" && sleep 5
php artisan dusk

rm -rf database/database.*.sqlite
success "Completed testing!"
